<?php
if(!defined('PLX_ROOT')) { exit; }

class kzScrolling extends plxPlugin {
	const HOOKS = array(
		'plxMotorPreChauffageBegin',
		'plxShowPagination',
		'ThemeEndBody',
	);
	const BOOKMARK = '-xhr-request';
	const MEDIA_QUERY = 'screen and (min-width: 45rem)';
	const BEGIN_CODE = '<?php' . PHP_EOL . '# ' . __CLASS__ . PHP_EOL;
	const END_CODE = PHP_EOL . '?>';

	public function __construct($lang) {
		parent::__construct($lang);
		if(!defined('PLX_ADMIN')) {
			foreach(self::HOOKS as $hook) {
				parent::addHook($hook, $hook);
			}
		}
	}

	public function plxMotorPreChauffageBegin() {
		echo self::BEGIN_CODE;
?>
if(preg_match('@(.*)-<?= strtoupper(__CLASS__) ?>$@', $this->get, $matches)) {
	$this->get = $matches[1];
	define(strtoupper(__CLASS__), true);
}
<?php
		echo self::END_CODE;
	}

	/**
	 * Remplace les boutons de pages dans la pagination par une barre de progression <progress>.
	 *
	 * La barre de progression doit avoir les attributs supplémentaires suivants :
	 *  - data-url contient l'adresse Url de la prochaine page à afficher
	 *  - data-pages-count est égal au nombre maxi de pages
	 **/
	public function plxShowPagination() {
		echo self::BEGIN_CODE;
?>
echo <<< EOT
	<!-- <?= __CLASS__ ?> plugin -->
	<progress class="<?= __CLASS__ ?>-progress" value="{$this->plxMotor->page}" max="{$last_page}" data-url="{$n_url}"></progress>

EOT;
return true;
<?php
		echo self::END_CODE;
	}

	/**
	 * Insère un script javascript en bas de page pour gérer le scrolling infini.
	 **/
	public function ThemeEndBody() {
		if(defined(strtoupper(__CLASS__))) {
			return;
		}
?>
	<script type="text/javascript" src="<?= PLX_PLUGINS . __CLASS__ . '/' . __CLASS__ ?>.js" data-media-query="<?= self::MEDIA_QUERY ?>"></script>
<?php
	}
}
